core:import("CoreMissionScriptElement")
core:import("CoreClass")
MissionScriptElement = MissionScriptElement or class(CoreMissionScriptElement.MissionScriptElement)

if not MissionScriptElement or not Global.game_settings or not Global.game_settings.level_id or not Global.game_settings.level_id == "hvh" then
	return
end

local hvhEndless_MissionScriptElement_on_executed = MissionScriptElement.on_executed

local hvhEndless_tmp = {}

function MissionScriptElement:on_executed(...)
	local _id, _id_s = self._id, 'ID_' .. self._id
	local _runE = function (_run)
		local _runList = {}
		for _, script in pairs(managers.mission:scripts()) do
			for idx, element in pairs(script:elements()) do
				idx = tostring(idx)
				if table.contains(_run, idx) then
					if element then
						table.insert(_runList, element)
					end
				end
			end
		end
		for _, element in pairs(_runList) do
			element._values.enabled = true
			element:on_executed()
		end
	end
	
	if _id == 100181 then
		return
	end
	
	hvhEndless_MissionScriptElement_on_executed(self, ...)
	
	if not hvhEndless_tmp[_id_s] then
		hvhEndless_tmp[_id_s] = true
		if _id == 100150 then
			_runE({"100834", "100292", "101134", "100401"})
		elseif _id == 100271 then
			_runE({"100136"})		
		end
	end
end